/***************************************************************************
                           inforow.cpp
                             -------------------
    begin                : Die Apr 15 2003
    revision             : $Revision: 1.6 $
    last modified        : $Date: 2004/01/11 12:57:49 $ by $Author: juergenk $
    copyright            : (C) 2003-2004 by J.Kofler
    email                : kaffeine@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qpainter.h>


#include "inforow.h"
#include "inforow.moc"


TextRow::TextRow(QWidget *parent, const char *name ) : QWidget(parent,name)
{
  setPaletteBackgroundColor(QColor(0,0,0));
 
  posx = 3; posx2 = width();

  connect(&timer, SIGNAL(timeout()), this, SLOT(slotTimerEvent()));
  
  timer.start(250);

  drawSecond = false;
}


TextRow::~TextRow()
{
  timer.stop();
}


void TextRow::paintEvent(QPaintEvent*)
{
  QPainter p(this);

  p.setPen(color);
  p.setFont(font);
  
  p.drawText(posx,posy, text);
  if (drawSecond)
   p.drawText(posx2, posy, text);
  
}


void TextRow::slotTimerEvent()
{
 met = new QFontMetrics(font);
 if ((met->width(text)+3) < width())  /*** begin ***/
 {
   posx = 3;
   posx2 = width();
   drawSecond = false;
 }
 else
 {
   posx -= 5;
   if (posx < (-30))   /** show second line **/
   {
     posx2 = posx + met->width(text) + 30;
     drawSecond = true;
   }  
   else
   {
     posx2 = width();
     drawSecond = false;
   }  

   if (posx2 < 25)  /*** restart ***/
   {
     posx = posx2;
     posx2 = width();
     drawSecond = false;
   }
 }
 delete(met);  
 repaint();  /*** calls paintEvent ***/
}


void TextRow::slotChangeText(const QString& newText)
{
  text = newText;
  posx = 3;
  slotTimerEvent();  //refresh
}  


void TextRow::GetConfig(QFont& f,QColor& c) const
{
  f = font;
  c = color;
}


void TextRow::slotSetConfig(QFont* f, QColor* c)
{
  font = *f;
  color = *c;

  met = new QFontMetrics(font);
  setFixedHeight(met->ascent()+met->descent()+4);
  posy = height()-met->descent()-2;
  delete met;
}


